---
title: XMLHttpRequest.timeout
slug: Web/API/XMLHttpRequest/timeout
tags:
  - AJAX
  - Asynchronous XHR
  - Asynchronous XMLHttpRequest
  - Property
  - Reference
  - XHR
  - XMLHttpRequest
  - timeout
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p>The <code><strong>XMLHttpRequest.timeout</strong></code> property is an <code>unsigned long</code> representing the number of milliseconds a request can take before automatically being terminated. The default value is 0, which means there is no timeout. Timeout shouldn't be used for synchronous XMLHttpRequests requests used in a {{Glossary('document environment')}} or it will throw an <code>InvalidAccessError</code> exception. When a timeout happens, a <a href="/en-US/docs/Web/Events/timeout">timeout</a> event is fired. {{gecko_minversion_inline("12.0")}}</p>

<dl>
 <dd>
 <div class="note"><strong>Note:</strong> You may not use a timeout for synchronous requests with an owning window.</div>
 </dd>
 <dd><a href="/en-US/docs/Web/API/XMLHttpRequest/Synchronous_and_Asynchronous_Requests#Example_using_a_timeout">Using a timeout with an asynchronous request</a> </dd>
</dl>

<p>In Internet Explorer, the timeout property may be set only after calling the <a href="/en-US/docs/Web/API/XMLHttpRequest/open">open()</a> method and before calling the <a href="/en-US/docs/Web/API/XMLHttpRequest/send">send()</a> method.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var xhr = new XMLHttpRequest();
xhr.open('GET', '/server', true);

xhr.timeout = 2000; // time in milliseconds

xhr.onload = function () {
  // Request finished. Do processing here.
};

xhr.ontimeout = function (e) {
  // XMLHttpRequest timed out. Do something here.
};

xhr.send(null);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-timeout-attribute')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.timeout")}}</p>
